/*
* Code by Bodysoulspirit with the help from Jaymie from Team Vuo. Public Domain.
*/

#include "node.h"
#include "VuoGlContext.h"
#include <OpenGL/CGLMacro.h>
#include "VuoMeshUtility.h"
#include "VuoListPosition.h"

VuoModuleMetadata({
					 "title" : "Get Object Vertices",
					 "description" : "Outputs the vertices of a 3D Object as a 3D Points list. This doesn't retrieve the child objects, so flatten the object first with the Flatten Object node if the object has children. Code by Bodysoulspirit, with the help from Jaymie.",
					 "keywords" : ["Mesh", "Vertex", "Points", "Scene", "Reinterpret"],
					 "version" : "1.0.1",
});

void nodeEvent
(
	VuoInputData(VuoSceneObject) object,
	VuoOutputData(VuoList_VuoPoint3d) pointsList
)
{
	*pointsList = VuoListCreate_VuoPoint3d();
	VuoMesh m = VuoSceneObject_getMesh(object);
	float *positions = 0;
	unsigned int vertexCount = 0;
	VuoMesh_getCPUBuffers(m, &vertexCount, &positions, NULL, NULL, NULL, NULL, NULL);
	for(unsigned int i = 0; i < vertexCount; i++)
	{
		VuoPoint3d currentPoint = (VuoPoint3d){ positions[i*3+0], positions[i*3+1], positions[i*3+2] };
		VuoListAppendValue_VuoPoint3d(*pointsList, currentPoint);
	}
}
